SystemOrganization addCategory: #'PuzzleDistribue-BackEnd'!

Object subclass: #BackEndAppliPuzzleDistribue
	instanceVariableNames: 'middleware'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PuzzleDistribue-BackEnd'!

BackEndAppliPuzzleDistribue class
	instanceVariableNames: 'default'!

!BackEndAppliPuzzleDistribue commentStamp: 'NouryBouraqadi 10/3/2012 11:59' prior: 0!
Utiliser avec InterfaceAppliPuzzleDistribue sur 2 images diffrentes. L'image 1 doit contenir le code pour le BackEnd et la catgorie Puzzle. L'image2 doit contenir le code pour l'interface et la catgorie GridView. Les 2 images doivent contenir SimpleMiddleware.

Pour lancer l'exemple du Puzzle distribuer, excuter les codes suivants dans des workspaces des imags indiques. Respecter l'ordre.

"Image 1"
backEnd := BackEndAppliPuzzleDistribue new.

"Image 2"
interface := InterfaceAppliPuzzleDistribue new.

"Image 1"
backEnd finInitialisation.

"Image 2"
interface finInitialisation.
interface demarrer.

Pour arrter l'application (arrter les middleware), excuter:
"Image 1"
backEnd stop.

"Image 2"
interface stop.
!

BackEndAppliPuzzleDistribue class
	instanceVariableNames: 'default'!

!BackEndAppliPuzzleDistribue class methodsFor: 'lancement' stamp: 'NouryBouraqadi 9/30/2013 11:36'!
arreter
	self default arreter! !

!BackEndAppliPuzzleDistribue class methodsFor: 'instance par defaut' stamp: 'NouryBouraqadi 9/30/2013 11:37'!
default
	^default ifNil: [ default := self new ]! !

!BackEndAppliPuzzleDistribue class methodsFor: 'lancement' stamp: 'NouryBouraqadi 9/30/2013 11:35'!
demarrer
	self default demarrer! !

!BackEndAppliPuzzleDistribue methodsFor: 'activite' stamp: 'NouryBouraqadi 9/30/2013 11:36'!
arreter
	middleware ifNil: [ ^self ].
	middleware stop! !

!BackEndAppliPuzzleDistribue methodsFor: 'activite' stamp: 'NouryBouraqadi 9/30/2013 11:36'!
demarrer
	self arreter.
	middleware := SeamlessDeamon newDefaultWithGlobalAccess.
	middleware startOn: 1111! !

Object subclass: #Piece
	instanceVariableNames: 'position couleur estSelectionnee'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PuzzleDistribue-BackEnd'!

!Piece methodsFor: 'observation' stamp: 'NouryBouraqadi 9/27/2012 11:24'!
addDependent: unObservateur
	super addDependent: unObservateur.
	self changed! !

!Piece methodsFor: 'accessing' stamp: 'NickPapoulias 9/30/2013 22:43'!
couleur
	^ By value: couleur! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 11:25'!
couleur: uneCouleur
	couleur := uneCouleur.
	self changed! !

!Piece methodsFor: 'selectionner' stamp: 'NouryBouraqadi 9/27/2012 16:55'!
deselectionner
	self estSelectionnee: false! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 12:18'!
estSelectionnee
	^estSelectionnee! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 12:26'!
estSelectionnee: unBooleen
	estSelectionnee := unBooleen.
	self changed! !

!Piece methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 9/27/2012 12:19'!
initialize 
	super initialize.
	self estSelectionnee: false! !

!Piece methodsFor: 'selectionner' stamp: 'NouryBouraqadi 9/28/2012 18:39'!
inverserSelection
	self estSelectionnee: self estSelectionnee not! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 10:47'!
position
	^position! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 12:26'!
position: unPoint
	position := unPoint.
	self changed! !

!Piece methodsFor: 'selectionner' stamp: 'NouryBouraqadi 9/28/2012 19:04'!
selectionner
	self estSelectionnee: true! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 15:44'!
x
	^self position x! !

!Piece methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 15:44'!
y
	^self position y! !

Object subclass: #Puzzle
	instanceVariableNames: 'pieces pieceSelectionnee'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PuzzleDistribue-BackEnd'!

!Puzzle methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 12:15'!
couleursDeBase
	^{Color red. Color cyan. Color green. Color yellow. Color magenta}.
! !

!Puzzle methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 9/27/2012 17:39'!
initialize 
	| unePiece positions unePosition |
	super initialize.
	pieces := Set new.
	self couleursDeBase do: [:uneCouleur|
		20 timesRepeat: [
				unePiece := Piece new.
				unePiece couleur: uneCouleur.
				pieces add: unePiece
			]
	].
	self melanger
! !

!Puzzle methodsFor: 'manipuler pieces' stamp: 'NouryBouraqadi 9/27/2012 17:44'!
intervertir: piece1 avec: piece2 
	|positionInitialePiece1|
	positionInitialePiece1 := piece1 position.
	piece1 position: piece2 position.
	piece2 position: positionInitialePiece1! !

!Puzzle methodsFor: 'manipuler pieces' stamp: 'NouryBouraqadi 10/3/2012 12:08'!
inverserSelectionPieceX: x y: y
	| pieceAInverser |
	pieceAInverser :=  self pieceEn: x@y.
	pieceAInverser inverserSelection.
	pieceSelectionnee ifNil: [
		pieceSelectionnee := pieceAInverser.
		^x@y].
	pieceSelectionnee == pieceAInverser ifFalse: [
		self intervertir: pieceAInverser avec: pieceSelectionnee.
		pieceAInverser deselectionner.
		pieceSelectionnee deselectionner].
	pieceSelectionnee := nil.
	^x@y! !

!Puzzle methodsFor: 'manipuler pieces' stamp: 'NouryBouraqadi 9/27/2012 18:02'!
melanger
	| piecesAMelanger unePiece |
	piecesAMelanger := self pieces copy.
	1 to: 10 do: [:x|
		1 to: 10 do: [:y|
			unePiece := piecesAMelanger atRandom.
			piecesAMelanger remove: unePiece.
			unePiece position: x@y
		]
	].
! !

!Puzzle methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 10:49'!
pieceEn: aPoint 
	^self pieces detect: [:unePiece| unePiece position = aPoint]! !

!Puzzle methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/27/2012 10:39'!
pieces
	^ pieces! !

TestCase subclass: #TestPuzzle
	instanceVariableNames: 'puzzle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PuzzleDistribue-BackEnd'!

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 18:35'!
assertAuMoinsDeuxCouleursAutourDe: unPoint
	| positions pieces couleurs |
	positions := self positionsAutourDe: unPoint.
	pieces := positions collect: [:position| puzzle pieceX: position x y: position y].
	couleurs := pieces collect: [:unePiece| unePiece couleur].
	self assert: couleurs asSet size > 1! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 10:48'!
positionsAutourDe: unPoint
	| positions nouveauPoint startDeltaX startDeltaY endDeltaX endDeltaY |
	positions := Set new.
	startDeltaX := unPoint x = 1 ifTrue: [0] ifFalse: [-1].
	startDeltaY := unPoint y = 1 ifTrue: [0] ifFalse: [-1].
	endDeltaX := unPoint x = 10 ifTrue: [0] ifFalse: [1].
	endDeltaY := unPoint y = 10 ifTrue: [0] ifFalse: [1].
	startDeltaX to: endDeltaX do: [:deltaX|
		startDeltaY to: endDeltaY do: [:deltaY|
				positions add: unPoint +(deltaX@deltaY)
	]].
	^positions! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 09:57'!
setUp
	super setUp.
	puzzle := Puzzle new! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 18:55'!
testAucunePieceSelectionneeApresSelectionDeDeuxPieces
	| tableauPieces piece1 piece2 positionInitialePiece1 positionInitialePiece2 |
	tableauPieces := puzzle pieces asArray.
	piece1 := tableauPieces first.
	piece2 := tableauPieces second.
	puzzle inverserSelectionPieceX: piece1 x y: piece1 y.
	puzzle inverserSelectionPieceX: piece2 x y: piece2 y.
	self assert: (puzzle pieces noneSatisfy: [:unePiece| unePiece estSelectionnee])	
! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 17:42'!
testIntervertirDeuxPieces
	| tableauPieces piece1 piece2 positionInitialePiece1 positionInitialePiece2 |
	tableauPieces := puzzle pieces asArray.
	piece1 := tableauPieces first.
	piece2 := tableauPieces second.
	positionInitialePiece1 := piece1 position.
	positionInitialePiece2 := piece2 position.
	puzzle intervertir: piece1 avec: piece2.
	self assert: piece1 position = positionInitialePiece2.
	self assert: piece2 position = positionInitialePiece1.
	
! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 18:55'!
testIntervertirDeuxPiecesSuccessivementSelectionnees
	| tableauPieces piece1 piece2 positionInitialePiece1 positionInitialePiece2 |
	tableauPieces := puzzle pieces asArray.
	piece1 := tableauPieces first.
	piece2 := tableauPieces second.
	positionInitialePiece1 := piece1 position.
	positionInitialePiece2 := piece2 position.
	puzzle inverserSelectionPieceX: piece1 x y: piece1 y.
	puzzle inverserSelectionPieceX: piece2 x y: piece2 y.
	self assert: piece1 position = positionInitialePiece2.
	self assert: piece2 position = positionInitialePiece1.
	
! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 17:46'!
testMelangePieces
	| tableauPieces positionsInitiales positionsApresMelange |
	tableauPieces := puzzle pieces asArray.
	positionsInitiales := tableauPieces collect: [:unePiece| unePiece position].
	puzzle melanger.
	positionsApresMelange := tableauPieces collect: [:unePiece| unePiece position].
	self deny: positionsInitiales = positionsApresMelange
! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 10:39'!
testNombreDePieces
	self assert: puzzle pieces size = 100! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 11:33'!
testPiecesInitialementColorees
	self deny: (puzzle pieces anySatisfy: [:unePiece| unePiece couleur isNil])! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 18:40'!
testPiecesInitialementDeselectionnees
	self assert: (puzzle pieces noneSatisfy: [:unePiece| unePiece estSelectionnee])! !

!TestPuzzle methodsFor: 'testing' stamp: 'NouryBouraqadi 9/27/2012 10:46'!
testPositionsDesPieces
	| positions |
	positions := puzzle pieces collect: [:unePiece| unePiece position].
	self assert: positions size = puzzle pieces size.
	self assert: (positions allSatisfy: [:unPoint| unPoint x > 0]).
	self assert: (positions allSatisfy: [:unPoint| unPoint y > 0]).
	self assert: (positions allSatisfy: [:unPoint| unPoint x < 11]).
	self assert: (positions allSatisfy: [:unPoint| unPoint y < 11])
	! !
